<app-header-toolbar></app-header-toolbar>

<ion-content>
  <div class="min-content-height">
    <ion-segment [(ngModel)]="routing.poolSegment" color="primary" (ionChange)="segmentChanged($event)">
      <ion-segment-button value="dashboard">
        Dashboard
      </ion-segment-button>
      <ion-segment-button value="blocks">
        Blocks
      </ion-segment-button>
      <ion-segment-button value="payments">
        Payments
      </ion-segment-button>
      <ion-segment-button value="ports">
        Ports
      </ion-segment-button>
    </ion-segment>
    <ng-container *ngIf="dataService.poolIdTable[poolLowerId]">
      <ion-row>
        <ion-col class="padding-sides">
          <ion-chip color="dark" *ngIf="pool.coin">
            <ion-chip-button slot="start" fill="clear" color="light">
              <ion-icon name="information-circle"></ion-icon>
            </ion-chip-button>
            <ion-label class="chip-info">Pool's coin: <strong>{{ pool.coin }}</strong></ion-label>
          </ion-chip>
          <ion-chip color="dark" *ngIf="pool.name">
            <ion-chip-button slot="start" fill="clear" color="light">
              <ion-icon name="information-circle"></ion-icon>
            </ion-chip-button>
            <ion-label class="chip-info">Pool name: <strong>{{ pool.name }}</strong></ion-label>
          </ion-chip>
          <ion-chip *ngIf="dataService.type" color="tertiary">
            <ion-label>Type filter: <strong>{{ dataService.type | poolType }}</strong></ion-label>
            <ion-chip-button slot="start" fill="clear" color="light" (click)="removeFilter('pool_type')">
              <ion-icon name="close-circle"></ion-icon>
            </ion-chip-button>
          </ion-chip>
        </ion-col>
        <ion-col class="padding-sides" text-right>
          <ion-button (click)="addFilter('pool_type')" size="small" color="secondary">
            <ion-icon slot="start" name="add"></ion-icon>
            Type Filter
          </ion-button>
          <ion-button (click)="addFilter('poolName')" size="small" color="secondary">
            <ion-icon slot="start" name="ios-analytics"></ion-icon>
            Change Pool
          </ion-button>
        </ion-col>
      </ion-row>
      <ng-container *ngIf="routing.poolSegment === 'dashboard'">
        <ion-row (window:resize)="onResize($event)">
          <ion-col text-center>
            <ion-card class="stats-widget">
              <ion-card-content>
                <h6 class="pool-value-header">{{ coin.name }} Value</h6>
                <div class="pool-value">${{ coin.usdPrice }}</div>
              </ion-card-content>
            </ion-card>
          </ion-col>
          <ion-col text-center>
            <ion-card class="stats-widget">
              <ion-card-content>
                <h6 class="pool-value-header">Network</h6>
                <div class="pool-value">{{ coin.networkHashRate }}</div>
              </ion-card-content>
            </ion-card>
          </ion-col>
          <ion-col text-center>
            <ion-card class="stats-widget">
              <ion-card-content>
                <h6 class="pool-value-header">Pool</h6>
                <div class="pool-value">{{ pool.hashRatePool | hash }}</div>
              </ion-card-content>
            </ion-card>
          </ion-col>
          <ion-col text-center>
            <ion-card class="stats-widget">
              <ion-card-content>
                <h6 class="pool-value-header">Miners</h6>
                <div class="pool-value">{{ pool.minersPool }}</div>
              </ion-card-content>
            </ion-card>
          </ion-col>
        </ion-row>
        <ion-grid class="animated fadeIn">
          <ng-container *ngIf="pool">
            <ng-container *ngIf="innerWidth > 1240">
              <ion-card class="stats-widget">
                <ion-card-header text-center>
                  Multi-Chart Overview of {{ pool.name }}
                </ion-card-header>
                <ion-card-content>
                  <app-pool-stats-chart></app-pool-stats-chart>
                </ion-card-content>
              </ion-card>
            </ng-container>
          </ng-container>
        </ion-grid>
      </ng-container>
      <ng-container *ngIf="routing.poolSegment === 'blocks'">
        <ion-grid class="blocks animated fadeIn" padding>
          <ion-row class="table-header-row">
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('valid')">
                <ion-label>Valid</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'valid'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changeFilter('ts')">
                <ion-label>Time</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'ts'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding" *ngIf="!dataService.type">
              <ion-item button (click)="changeFilter('pool_type')">
                <ion-label>Type</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'pool_type'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('hash')">
                <ion-label>Hash</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'hash'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('height')">
                <ion-label>Height</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'height'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('diff')">
                <ion-label>Difficulty</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'diff'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('unlocked')">
                <ion-label>Status</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'unlocked'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changeFilter('luck')">
                <ion-label>Luck</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'luck'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown'"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('shares')">
                <ion-label>Shares</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'shares'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
          </ion-row>
          <ion-card class="block-card" *ngFor="let block of blocks;">
            <ion-card-content class="transition" [class.odd-card]="blockHashTable[block.hash].index % 2 === 1"
              [class.changed]="hasChanged('', block)">
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('valid', block)">
                  <div class="centered-table-body">
                    <div class="centered-table-cell">
                      <strong class="parameter valid-time-status">Valid:</strong>
                      <ion-icon class="valid-status-icon" [class.valid]="block.valid" name="{{ block.valid ? 'checkmark' : 'alert'}}"></ion-icon>
                    </div>
                  </div>
                </ion-col>
                <ion-col>
                  <strong>Hash:</strong> <a class="hash-link" href="{{ block.hash | hashToLink: coin.id:'block' }}"
                    target="_blank" title="Link to blockchain explorer">{{
                    block.hash }}</a>
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('unlocked', block)">
                  <div class="centered-table-body">
                    <div class="centered-table-cell">
                      <strong class="parameter status-luck-shares">Status:</strong>
                      <ion-icon class="block-status-icon" name="{{ block.unlocked ? 'unlock' : 'lock' }}"></ion-icon>
                      <small>({{ block.unlocked ? 'Unlocked ' + networkHeight - block.height + ' blocks ago' :
                        block.height - networkHeight + ' blocks until unlocked' }})</small>
                    </div>
                  </div>
                </ion-col>
              </ion-row>
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('ts', block)">
                  <strong class="parameter valid-time-status" [class.changed]="hasChanged('ts', block)">Time:</strong>
                  {{ block.ts | fromNow }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('height', block)">
                  <strong class="parameter height-diff">Height:</strong> {{ block.height | number: '2.' }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('luck', block)">
                  <strong class="parameter status-luck-shares">Luck:</strong> {{ block.luck | blockLuck | number: '1.2'
                  }}%
                </ion-col>
              </ion-row>
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('unlocked', block)">
                  <strong class="parameter valid-time-status">Type:</strong> {{ block.pool_type | poolType }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('diff', block)">
                  <strong class="parameter height-diff">Difficulty:</strong> {{ block.diff | number : '2.' }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('shares', block)">
                  <strong class="parameter status-luck-shares">Shares:</strong> {{ block.shares | number: '2.' }}
                </ion-col>
              </ion-row>
            </ion-card-content>
          </ion-card>
        </ion-grid>
        <ion-infinite-scroll *ngIf="blocks.length > 0 && blocks.length !== 1000" class="infinite-white" threshold="100px"
          (ionInfinite)="loadMore($event)" [disabled]="dataService.limit === 1000">
          <ion-infinite-scroll-content color="light" loadingSpinner="crescent" loadingText="Loading more blocks...">
          </ion-infinite-scroll-content>
        </ion-infinite-scroll>
      </ng-container>
      <ng-container *ngIf="routing.poolSegment === 'payments'">
        <ion-grid class="blocks animated fadeIn" padding>
          <ion-row class="table-header-row">
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('hash')">
                <ion-label>Hash</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'hash'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changeFilter('ts')">
                <ion-label>Time</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'ts'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changeFilter('value')">
                <ion-label>Amount</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'value'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('fee')">
                <ion-label>Fee</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'fee'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('mixins')">
                <ion-label>Mixins</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'mixins'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item [disabled]="dataService.type" button (click)="changeFilter('payees')">
                <ion-label>Payees</ion-label>
                <ion-icon *ngIf="dataService.blockOrderBy === 'payees'" slot="end" name="{{ dataService.blockOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
          </ion-row>
          <ion-card class="block-card" *ngFor="let payment of payments;">
            <ion-card-content class="transition" [class.odd-card]="paymentHashTable[payment.hash].index % 2 === 1"
              [class.changed]="hasChanged('', payment)">
              <ion-row>
                <ion-col>
                  <strong class="parameter valid-time-status">Hash:</strong> <a class="hash-link" href="{{ payment.hash | hashToLink: coin.id:'tx' }}"
                    title="Link to blockchain explorer">{{ payment.hash }}</a>
                </ion-col>
              </ion-row>
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('ts', payment)">
                  <strong>Time:</strong> {{ payment.ts | fromNow }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('value', payment)">
                  <strong>Amount:</strong> {{ payment.value | coinValue | number: '1.8' }} {{ coin.id }} (${{
                  payment.value * coin.usdPrice | coinValue | number: '1.1' }})
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('fee', payment)">
                  <strong>Fee:</strong> {{ payment.fee | coinValue | number: '1.8' }} {{ coin.id }} (${{ payment.fee *
                  coin.usdPrice | coinValue | number: '1.1' }})
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('payees', payment)">
                  <strong>Payees:</strong> {{ payment.payees }}
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('mixins', payment)">
                  <strong>Mixins:</strong> {{ payment.mixins }}
                </ion-col>
              </ion-row>
            </ion-card-content>
          </ion-card>
        </ion-grid>
        <ion-infinite-scroll *ngIf="payments.length > 0 && payments.length !== 1000" class="infinite-white" threshold="100px"
          (ionInfinite)="loadMore($event)" [disabled]="dataService.limit === 1000">
          <ion-infinite-scroll-content color="light" loadingSpinner="crescent" loadingText="Loading more payments...">
          </ion-infinite-scroll-content>
        </ion-infinite-scroll>
      </ng-container>
      <ng-container *ngIf="routing.poolSegment === 'ports'">
        <ion-grid class="blocks animated fadeIn" padding>
          <ion-row class="table-header-row">
            <ion-col *ngIf="!dataService.type" class="no-padding">
              <ion-item button (click)="changePortFilter('pool_type')">
                <ion-label>Type</ion-label>
                <ion-icon *ngIf="portOrderBy === 'pool_type'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('difficulty')">
                <ion-label>Difficulty</ion-label>
                <ion-icon *ngIf="portOrderBy === 'difficulty'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('hostname')">
                <ion-label>Host</ion-label>
                <ion-icon *ngIf="portOrderBy === 'hostname'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('port')">
                <ion-label>Port</ion-label>
                <ion-icon *ngIf="portOrderBy === 'port'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('miners')">
                <ion-label>Miners</ion-label>
                <ion-icon *ngIf="portOrderBy === 'miners'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('blockID')">
                <ion-label>Block</ion-label>
                <ion-icon *ngIf="portOrderBy === 'blockID'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
            <ion-col class="no-padding">
              <ion-item button (click)="changePortFilter('blockIDTime')">
                <ion-label>Block Time</ion-label>
                <ion-icon *ngIf="portOrderBy === 'blockIDTime'" slot="end" name="{{ portOrderByAsc ? 'arrow-dropup' : 'arrow-dropdown' }}"></ion-icon>
              </ion-item>
            </ion-col>
          </ion-row>
          <ion-card class="block-card" *ngFor="let port of ports | textFilter: ['type', dataService.type] | sortBy: [portOrderBy, portOrderByAsc]; let i = index;">
            <ion-card-content class="transition" [class.odd-card]="i % 2 === 1" [class.changed]="hasChanged('', port)">
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('type', port)" [class.sort-active]="portOrderBy === 'type'">
                  <strong class="parameter valid-time-status">Type:</strong> <span>{{ port.type }}</span>
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('description', port)" [class.sort-active]="portOrderBy === 'description'">
                  <strong class="parameter valid-time-status">Description:</strong> <span>{{ port.description }}</span>
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('miners', port)" [class.sort-active]="portOrderBy === 'miners'">
                  <strong class="parameter valid-time-status">Active Miners:</strong> <span>{{ port.miners | number:
                    '1.' }}</span>
                </ion-col>
              </ion-row>
              <ion-row>
                <ion-col class="transition" [class.changed]="hasChanged('difficulty', port)" [class.sort-active]="portOrderBy === 'difficulty'">
                  <strong class="parameter valid-time-status">Difficulty:</strong> <span>{{ port.difficulty | number:
                    '1.' }}</span>
                </ion-col>
                <ion-col class="transition" [class.sort-active]="portOrderBy === 'hostname' || portOrderBy === 'port'">
                  <strong class="parameter valid-time-status">Host:Port:</strong> <span>{{ port.hostname }}:{{
                    port.port }}</span>
                  <ng-container *ngIf="port.ip">(IP: {{ port.ip }})</ng-container>
                </ion-col>
                <ion-col class="transition" [class.changed]="hasChanged('blockIDTime', port) || hasChanged('blockID', port)"
                  [class.sort-active]="portOrderBy === 'blockID' || portOrderBy === 'blockIDTime'">
                  <strong class="parameter valid-time-status">Block ID/Time:</strong> <span>{{ port.blockID }}</span>
                  ({{port.blockIDTime | fromNow }})
                </ion-col>
              </ion-row>
            </ion-card-content>
          </ion-card>
        </ion-grid>
      </ng-container>
    </ng-container>
  </div>
  <app-legal-footer></app-legal-footer>
</ion-content>